import { CryptoProvider } from "../crypto/CryptoProvider";
/**
 * Client assertion of type jwt-bearer used in confidential client flows
 */
export declare class ClientAssertion {
    private jwt;
    private privateKey;
    private thumbprint;
    private expirationTime;
    private issuer;
    private jwtAudience;
    private publicCertificate;
    static fromAssertion(assertion: string): ClientAssertion;
    static fromCertificate(thumbprint: string, privateKey: string, publicCertificate?: string): ClientAssertion;
    getJwt(cryptoProvider: CryptoProvider, issuer: string, jwtAudience: string): string;
    private createJwt;
    private isExpired;
    /**
     * Extracts the raw certs from a given certificate string and returns them in an array.
     * @param publicCertificate
     */
    static parseCertificate(publicCertificate: string): Array<string>;
}
